######### Variable Definitions
set $saml_request_id "";
set $saml_response_id "";

set $internal_error_message "SAML Authentication failed. If problem persists, contact your system administrator. ";

js_var $internal_error_details;

######### Flow Configuration

location = /saml/acs {
  client_max_body_size 64k;
  client_body_buffer_size 64k;
  gunzip on;

  # SAML Assertion Consumer Service (or ACS) location.
  # Receiving and processing SAML <samlp:Response> messages from IdP.
  js_content samlsp.handleSingleSignOn;
  status_zone "SAMLSSO ACS";
  error_page 500 @saml_error;
}

location = /saml/sls {
  client_max_body_size 64k;
  client_body_buffer_size 64k;
  gunzip on;

  # SAML Single Logout Service (or SLS) location.
  # Receiving and processing SAML <samlp:LogoutResponse>
  # or <samlp:LogoutRequest> messages from IdP.
  js_content samlsp.handleSingleLogout;
  status_zone "SAMLSSO SLS";
  error_page 500 @saml_error;
}

location @do_samlsp_flow {
  client_max_body_size 64k;
  client_body_buffer_size 64k;
  gunzip on;

  # Named location that initiates SAML Authentication by sending
  # SAML <samlp:AuthnRequest> to the IdP if the user session is not found.
  js_content samlsp.initiateSingleSignOn;
  set $cookie_auth_token "";
}

location = /logout {
  client_max_body_size 64k;
  client_body_buffer_size 64k;
  gunzip on;

  # Requests to this location initiate the logout process by sending
  # SAML <samlp:LogoutRequest> to the IdP.
  js_content samlsp.initiateSingleLogout;
  status_zone "SAMLSSO logout";
  error_page 500 @saml_error;
}

location = /_logout {
  client_max_body_size 64k;
  client_body_buffer_size 64k;
  gunzip on;

  # This location is the default value of $saml_logout_landing_page.
  default_type text/plain;
  return 200 "Logged out\n";
}

location @saml_error {
  client_max_body_size 64k;
  client_body_buffer_size 64k;
  gunzip on;

  # This location is called when any SAML SSO error occurs
  status_zone "SAMLSP error";
  default_type text/plain;
  return 500 "$internal_error_message $internal_error_details";
}
